package it.micegroup.gestioneferie.pianificazioneferie.assembler;

import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.linkTo;
import static org.springframework.hateoas.server.mvc.WebMvcLinkBuilder.methodOn;
import org.springframework.hateoas.CollectionModel;
import org.springframework.hateoas.Link;
import org.springframework.stereotype.Component;

import it.micegroup.gestioneferie.libs.assembler.BaseModelAssembler;
import it.micegroup.gestioneferie.pianificazioneferie.controller.DstatiRichAdesionePfController;
import it.micegroup.gestioneferie.pianificazioneferie.dto.DstatiRichAdesionePfDto;
import it.micegroup.gestioneferie.pianificazioneferie.entity.DstatiRichAdesionePf;

import it.micegroup.gestioneferie.pianificazioneferie.controller.DrichAdesionePfController;

@Component
public class DstatiRichAdesionePfModelAssembler
		extends BaseModelAssembler<DstatiRichAdesionePf, DstatiRichAdesionePfDto, DstatiRichAdesionePfController> {

	@Override
	public DstatiRichAdesionePfDto toModel(DstatiRichAdesionePf dstatiRichAdesionePf) {
		DstatiRichAdesionePfDto dstatiRichAdesionePfDto = map(dstatiRichAdesionePf, DstatiRichAdesionePfDto.class,
				DstatiRichAdesionePfController.class);

		// SELF LINK
		Link selfLink = convert(linkTo(
				methodOn(DstatiRichAdesionePfController.class).getByObjectKey(dstatiRichAdesionePf.getObjectKey()))
						.withSelfRel());
		dstatiRichAdesionePfDto.add(selfLink);

		// PARENT LINKS

		// CHILDREN LINKS
		if (dstatiRichAdesionePf.getTheDrichAdesionePf() != null) {
			Link drichAdesionePfLink = convert(linkTo(methodOn(DrichAdesionePfController.class)
					.findByDstatiRichAdesionePf(dstatiRichAdesionePf.getObjectKey(), null))
							.withRel("theDrichAdesionePf"));
			dstatiRichAdesionePfDto.add(drichAdesionePfLink);
		}

		// PARENTS LINKS FOR IMPORTED MS

		// CHILDREN LINKS FOR IMPORTED MS

		return dstatiRichAdesionePfDto;

	}

	@Override
	public CollectionModel<DstatiRichAdesionePfDto> toCollectionModel(
			Iterable<? extends DstatiRichAdesionePf> entities) {
		CollectionModel<DstatiRichAdesionePfDto> collectionEntities = super.toCollectionModel(entities);
		// collectionEntities.add(linkTo(methodOn(OrdineController.class).findPaginated(null,
		// null)).withSelfRel());

		return collectionEntities;
	}

}

